/*
   Denial-Of-Service firewall
   Copyright (c) 1999  Martin Hinner <mhi@penguin.cz>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __DOSFW_H
#define __DOSFW_H

#include "config.h"

#include <linux/skbuff.h>

typedef int dosfw_hookfn(struct sk_buff *skb);

struct dosfw_hook {
 struct dosfw_hook *next;
 dosfw_hookfn *hook;
 char *name;
};

#define DOSFW_ACCEPT      0
#define DOSFW_REJECT      1

extern int dosfw_register(struct dosfw_hook *hook);

#ifdef CONFIG_DOSFW_LAND
extern void register_land(void);
#endif

#ifdef CONFIG_DOSFW_ECHOLOOP
extern void register_echoloop(void);
#endif

#ifdef CONFIG_DOSFW_FINGERPRINT
extern void register_fingerprint(void);
#endif

#endif
