/*
   Denial-Of-Service firewall
   Copyright (c) 1999  Martin Hinner <mhi@penguin.cz>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <linux/kernel.h>

#include <linux/ip.h>
#include <linux/tcp.h>

#include "dosfw.h"

int land_attack(struct sk_buff *skb);

struct dosfw_hook land_hook = {
	NULL,
	land_attack,
	"land"
};

void register_land()
{
	dosfw_register(&land_hook);
}

int land_attack(struct sk_buff *skb)
{
	const struct iphdr *ip = skb->nh.iph;
	struct tcphdr *tcp;

	if (ip->protocol != IPPROTO_TCP)
		return DOSFW_ACCEPT;
 
	tcp = (struct tcphdr *)((__u32 *)ip+ip->ihl);

	if (ip->saddr != ip->daddr)
		return DOSFW_ACCEPT;			

	if (tcp->source != tcp->dest)
		return DOSFW_ACCEPT;

	printk("[dosfw] Land attack detected! [%ld.%ld.%ld.%ld:%hu]\n",
		(ntohl(ip->saddr)>>24)&0xFF,
		(ntohl(ip->saddr)>>16)&0xFF,
		(ntohl(ip->saddr)>>8)&0xFF,
		(ntohl(ip->saddr))&0xFF,
		ntohs(tcp->source));
		
	return DOSFW_REJECT;
}
